/*
 * Copyright 2004-2006 Robbie.JP
 */
package robbie.dao.resource;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.XADataSource;

import robbie.dao.DaoSysException;

/**
 * S2DataSourceResourceNXB<p>
 * S2Container̃f[^\[X𗘗pꍇDbResourceB
 * @author Tadahiro Murakami
 */
public class SimpleXADataSourceResource implements DbResource {
    
    private static final long serialVersionUID = 5554156609678001644L;
    
    /** f[^\[X */
    protected XADataSource dataSource = null;
    
    /**
     * RXgN^B
     */
    public SimpleXADataSourceResource() {
    }

    /**
     * XADataSource ݒB<p>
     * ̏DIReioRōsB
     * Seasar2ɂ͈ˑȂB
     * @param dataSource
     */
    public void setXaDataSource(XADataSource dataSource) {
        this.dataSource = dataSource;
    }
    
    /**
     * RlNVԂ
     * @return ConnectionIuWFNg
     */
    public Connection getConnection() {
        try {
            return new SimpleConnectionWrapper(dataSource.getXAConnection().getConnection());
        } catch(SQLException ex) {
            throw new DaoSysException("f[^x[X̃RlNV̎擾Ɏs܂.", ex);
        }
    }
    
    /**
     * \[X[X܂B<p>
     */
    public void release() {
        // ͓ɉȂ
    }
    
    /**
     * toString()̃I[oChB<p>
     * @return ̃CX^X̕\L
     */
    public String toString() {
        return "DataSource=" + dataSource;
    }
}
