/*
 * Copyright 2004-2007 Robbie.JP
 */
package robbie.util;

import java.util.Collection;

/**
 * CollectionUtilNXB<p>
 * @author Tadahiro Murakami
 */
public class CollectionsUtil {

    private CollectionsUtil() {
    }
    
    protected static java.util.List createList(java.util.List list) {
        return (java.util.List)ProxyFactory.createProxy(
                java.util.List.class, 
                new ListToStringInvocationHandler(list));
    }
    
    protected static java.util.Map createMap(java.util.Map map) {
        return (java.util.Map)ProxyFactory.createProxy(
                java.util.Map.class, 
                new MapToStringInvocationHandler(map));
    }
    
    /**
     * e10ŋList쐬ĕԂ܂B<p>
     * @return ListCX^X
     */
    public static java.util.List createList() {
        return createList(new java.util.ArrayList());
    }
    
    /**
     * w肳ꂽRNV̗vf܂List쐬ĕԂ܂B <p>
     * @param c w肵RNV
     * @return ListCX^X
     */
    public static java.util.List createList(Collection c) {
        return createList(new java.util.ArrayList(c));
    }
    
    /**
     * w肳ꂽTCYŋList쐬ĕԂ܂B <p>
     * @param initialCapacity TCY
     * @return ListCX^X
     */
    public static java.util.List createList(int initialCapacity) {
        return createList(new java.util.ArrayList(initialCapacity));
    }
    
    /**
     * ftHg̗e (16) ƕ׌W (0.75) ŋMapCX^X쐬ĕԂ܂B<p>
     * @return MapCX^X
     */
    public static java.util.Map createMap() {
        return createMap(new java.util.LinkedHashMap());
    }
    
    /**
     * w肳ꂽeʂƃftHg̕׌W (0.75) ŋMapCX^X쐬ĕԂ܂B<p>
     * @param initialCapacity e
     * @return MapCX^X
     */
    public static java.util.Map createMap(int initialCapacity) {
        return createMap(new java.util.LinkedHashMap(initialCapacity));
    }
    
    /**
     * w肳ꂽeʂƕ׌WŋMapCX^X쐬ĕԂ܂B<p>
     * @param initialCapacity e
     * @param loadFactor ׌W
     * @return MapCX^X
     */
    public static java.util.Map createMap(int initialCapacity, float loadFactor) {
        return createMap(new java.util.LinkedHashMap(initialCapacity, loadFactor));
    }
    
    /**
     * w肳ꂽeʁA׌WAя[hŁAMapCX^X쐬ĕԂ܂B<p>
     * @param initialCapacity e
     * @param loadFactor ׌W
     * @param accessOrder [h
     * @return MapCX^X
     */
    public static java.util.Map createMap(int initialCapacity, float loadFactor, boolean accessOrder) {
        return createMap(new java.util.LinkedHashMap(initialCapacity, loadFactor, accessOrder));
    }
    
}
