/*
 * Copyright 2007 Robbie.JP
 */
package robbie.util;

import java.lang.reflect.Method;
import java.util.Iterator;

/**
 * MapToStringInvocationHandlerNX.<p>
 * @author muramura
 */
public class MapToStringInvocationHandler extends BaseInvocationHandler {

    /**
     * RXgN^.<p>
     * @param obj
     */
    public MapToStringInvocationHandler(Object obj) {
        super(obj);
    }

    /* (non-Javadoc)
     * @see robbie.util.BaseInvocationHandler#invoke(java.lang.Object, java.lang.reflect.Method, java.lang.Object[])
     */
    public Object invoke(Object proxy, Method method, Object[] args) {
        if (!method.getName().equals("toString")) {
            return super.invoke(proxy, method, args);
        }
        
        if (beanObject instanceof java.util.Map) {
            
            java.util.Map map = (java.util.Map)beanObject;
            
            String ls = System.getProperty("line.separator");
            StringBuffer buffer = new StringBuffer();
            
            buffer.append("Map.size()=");
            buffer.append(map.size());
            buffer.append(ls);
            int i=0;
            for (Iterator it=map.entrySet().iterator(); it.hasNext();i++) {
                java.util.Map.Entry entry = (java.util.Map.Entry)it.next();
                buffer.append("  ");
                buffer.append(i);
                buffer.append(") ");
                buffer.append("key:");
                buffer.append(entry.getKey());
                buffer.append("(");
                buffer.append(entry.getKey().getClass().getName());
                buffer.append(")");
                buffer.append(" value:");
                buffer.append(entry.getValue());
                buffer.append("(");
                if (entry.getValue() != null) {
                    buffer.append(entry.getValue().getClass().getName());
                } else {
                    buffer.append("null");
                }
                buffer.append(")");
                buffer.append(ls);
            }
            return buffer.toString();
        }
        return beanObject.toString();
    }
    
    
}
